Tonyu.klass.define({
  fullName: 'user.Node',
  shortName: 'Node',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Node_main() {
        "use strict";
        var _this=this;
        
        _this.radius=20;
        _this.fillStyle="white";
        _this.alpha=200;
        _this.on("touch",(function anonymous_312() {
          
          if (! Tonyu.globals.$from) {
            _this.all(Tonyu.classes.user.Node).attr({fillStyle: "white"});
            _this.all(Tonyu.classes.user.Path).die();
            _this.all(Tonyu.classes.user.Searcher).die();
            Tonyu.globals.$from=_this;
            _this.fillStyle="red";
            
          } else {
            _this.s=new Tonyu.classes.user.Searcher({from: Tonyu.globals.$from,to: _this,path: new Tonyu.classes.user.Path});
            _this.fillStyle="cyan";
            _this.s.on("result",(function anonymous_597(paths) {
              var path;
              var _it_379;
              
              _it_379=Tonyu.iterator(paths,1);
              while(_it_379.next()) {
                path=_it_379[0];
                
                _this.print(path.toString());
                
              }
            }));
            Tonyu.globals.$from=null;
            
          }
        }));
      },
      fiber$main :function _trc_Node_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.radius=20;
        _this.fillStyle="white";
        _this.alpha=200;
        _this.on("touch",(function anonymous_312() {
          
          if (! Tonyu.globals.$from) {
            _this.all(Tonyu.classes.user.Node).attr({fillStyle: "white"});
            _this.all(Tonyu.classes.user.Path).die();
            _this.all(Tonyu.classes.user.Searcher).die();
            Tonyu.globals.$from=_this;
            _this.fillStyle="red";
            
          } else {
            _this.s=new Tonyu.classes.user.Searcher({from: Tonyu.globals.$from,to: _this,path: new Tonyu.classes.user.Path});
            _this.fillStyle="cyan";
            _this.s.on("result",(function anonymous_597(paths) {
              var path;
              var _it_379;
              
              _it_379=Tonyu.iterator(paths,1);
              while(_it_379.next()) {
                path=_it_379[0];
                
                _this.print(path.toString());
                
              }
            }));
            Tonyu.globals.$from=null;
            
          }
        }));
        
        _thread.retVal=_this;return;
      },
      draw :function _trc_Node_draw(ctx) {
        "use strict";
        var _this=this;
        
        __superClass.prototype.draw.apply( _this, [ctx]);
        ctx.font="15px monospace";
        ctx.fillStyle="black";
        ctx.fillText(_this.toString(),_this.x-10,_this.y);
      },
      isConnected :function _trc_Node_isConnected(otherNode) {
        "use strict";
        var _this=this;
        
        return _this.within(otherNode,_this.radius*2);
      },
      fiber$isConnected :function _trc_Node_f_isConnected(_thread,otherNode) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.within(otherNode,_this.radius*2);return;
        
        
        _thread.retVal=_this;return;
      },
      allConnected :function _trc_Node_allConnected() {
        "use strict";
        var _this=this;
        
        return _this.allWithin(Tonyu.classes.user.Node,_this.radius*2);
      },
      fiber$allConnected :function _trc_Node_f_allConnected(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.allWithin(Tonyu.classes.user.Node,_this.radius*2);return;
        
        
        _thread.retVal=_this;return;
      },
      toString :function _trc_Node_toString() {
        "use strict";
        var _this=this;
        
        return _this.name+"";
      },
      fiber$toString :function _trc_Node_f_toString(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.name+"";return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true},"isConnected":{"nowait":false},"allConnected":{"nowait":false},"toString":{"nowait":false}},"fields":{"s":{},"name":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.setBGColor("black");
        Tonyu.globals.$from=null;
        _this.sampleMap();
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.setBGColor("black");
        Tonyu.globals.$from=null;
        
        _thread.enter(function _trc_Main_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$sampleMap(_thread);
              __pc=1;return;
            case 1:
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      sampleMap :function _trc_Main_sampleMap() {
        "use strict";
        var _this=this;
        
        _this.x=100;
        _this.y=100;
        _this.seq=1;
        _this.i=0;for (; _this.i<5 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.x+=38;
          }
        }
        _this.i=0;for (; _this.i<8 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.y+=38;
          }
        }
        _this.x=180;
        _this.y=135;
        _this.i=0;for (; _this.i<7 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.y+=38;
          }
        }
        _this.x=200;
        _this.y=210;
        _this.i=0;for (; _this.i<3 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.x+=30;
          }
        }
        _this.p=- 1;
      },
      fiber$sampleMap :function _trc_Main_f_sampleMap(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.x=100;
        _this.y=100;
        _this.seq=1;
        _this.i=0;for (; _this.i<5 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.x+=38;
          }
        }
        _this.i=0;for (; _this.i<8 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.y+=38;
          }
        }
        _this.x=180;
        _this.y=135;
        _this.i=0;for (; _this.i<7 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.y+=38;
          }
        }
        _this.x=200;
        _this.y=210;
        _this.i=0;for (; _this.i<3 ; _this.i++) {
          Tonyu.checkLoop();
          {
            new Tonyu.classes.user.Node({x: _this.x,y: _this.y,name: _this.seq});
            _this.seq++;
            _this.x+=30;
          }
        }
        _this.p=- 1;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"sampleMap":{"nowait":false}},"fields":{"seq":{},"i":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Path',
  shortName: 'Path',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Path_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Path_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Path_initialize(p) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [p]);
        _this.nodes=_this.nodes||[];
        _this.strokeStyle=_this.strokeStyle||new Tonyu.classes.kernel.Color({h: _this.rnd(360),s: 1,l: 0.5});
      },
      draw :function _trc_Path_draw(ctx) {
        "use strict";
        var _this=this;
        var first;
        var node;
        var _it_382;
        
        first = true;
        
        ctx.strokeStyle=_this.strokeStyle+"";
        ctx.lineWidth=2;
        ctx.beginPath();
        _it_382=Tonyu.iterator(_this.nodes,1);
        while(_it_382.next()) {
          node=_it_382[0];
          
          if (first) {
            ctx.moveTo(node.x,node.y);
          } else {
            ctx.lineTo(node.x+_this.rnd(- 5,5),node.y+_this.rnd(- 5,5));
          }
          first=false;
          
        }
        ctx.stroke();
      },
      add :function _trc_Path_add(node) {
        "use strict";
        var _this=this;
        
        _this.nodes.push(node);
      },
      fiber$add :function _trc_Path_f_add(_thread,node) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.nodes.push(node);
        
        _thread.retVal=_this;return;
      },
      contains :function _trc_Path_contains(node) {
        "use strict";
        var _this=this;
        
        return _this.nodes.indexOf(node)>=0;
      },
      fiber$contains :function _trc_Path_f_contains(_thread,node) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.nodes.indexOf(node)>=0;return;
        
        
        _thread.retVal=_this;return;
      },
      clone :function _trc_Path_clone() {
        "use strict";
        var _this=this;
        
        return new Tonyu.classes.user.Path({nodes: _this.nodes.slice()});
      },
      fiber$clone :function _trc_Path_f_clone(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=new Tonyu.classes.user.Path({nodes: _this.nodes.slice()});return;
        
        
        _thread.retVal=_this;return;
      },
      toString :function _trc_Path_toString() {
        "use strict";
        var _this=this;
        
        return _this.nodes.map((function anonymous_586(node) {
          
          return node+"";
        })).join("->");
      },
      fiber$toString :function _trc_Path_f_toString(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.nodes.map((function anonymous_586(node) {
          
          return node+"";
        })).join("->");return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"draw":{"nowait":true},"add":{"nowait":false},"contains":{"nowait":false},"clone":{"nowait":false},"toString":{"nowait":false}},"fields":{"nodes":{},"strokeStyle":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Searcher',
  shortName: 'Searcher',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Searcher_main() {
        "use strict";
        var _this=this;
        var _it_387;
        var _it_388;
        
        "field strict";
        
        
        _this.current = _this.from;
        
        _this.path.add(_this.current);
        while (true) {
          Tonyu.checkLoop();
          if (_this.current===_this.to) {
            _this.report([_this.path]);
            break;
            
            
          }
          _this.x=_this.current.x;
          _this.y=_this.current.y;
          _this.neighbors = [];
          
          _it_387=Tonyu.iterator(_this.current.allConnected(),1);
          while(_it_387.next()) {
            _this.neighbor=_it_387[0];
            
            if (_this.path.contains(_this.neighbor)) {
              continue;
              
            }
            _this.neighbors.push(_this.neighbor);
            
          }
          if (_this.neighbors.length==0) {
            _this.path.die();
            _this.report([]);
            
          } else {
            if (_this.neighbors.length==1) {
              _this.current=_this.neighbors[0];
              _this.path.add(_this.current);
              
            } else {
              _this.count = _this.neighbors.length;
              
              _it_388=Tonyu.iterator(_this.neighbors,1);
              while(_it_388.next()) {
                _this.neighbor=_it_388[0];
                
                _this.s = new Tonyu.classes.user.Searcher({from: _this.neighbor,to: _this.to,path: _this.path.clone()});
                
                _this.allPaths = [];
                
                _this.s.on("result",(function anonymous_753(paths) {
                  
                  _this.allPaths=_this.allPaths.concat(paths);
                  _this.count--;
                  if (_this.count==0) {
                    _this.report(_this.allPaths);
                    
                  }
                }));
                
              }
              _this.path.die();
              _this.alpha=128;
              break;
              
              
            }
          }
          _this.updateEx(5);
          
        }
      },
      fiber$main :function _trc_Searcher_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_387;
        var _it_388;
        
        "field strict";
        
        
        _this.current = _this.from;
        
        _this.path.add(_this.current);
        
        _thread.enter(function _trc_Searcher_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.current===_this.to)) { __pc=3     ; break; }
              _this.fiber$report(_thread, [_this.path]);
              __pc=2;return;
            case 2:
              
              __pc=12    ; break;
              
            case 3     :
              
              _this.x=_this.current.x;
              _this.y=_this.current.y;
              _this.neighbors = [];
              
              _it_387=Tonyu.iterator(_this.current.allConnected(),1);
              while(_it_387.next()) {
                _this.neighbor=_it_387[0];
                
                if (_this.path.contains(_this.neighbor)) {
                  continue;
                  
                }
                _this.neighbors.push(_this.neighbor);
                
              }
              if (!(_this.neighbors.length==0)) { __pc=5     ; break; }
              _this.path.die();
              _this.fiber$report(_thread, []);
              __pc=4;return;
            case 4:
              
              __pc=10    ;break;
            case 5     :
              if (!(_this.neighbors.length==1)) { __pc=6     ; break; }
              {
                _this.current=_this.neighbors[0];
                _this.path.add(_this.current);
              }
              __pc=9     ;break;
            case 6     :
              _this.count = _this.neighbors.length;
              
              _it_388=Tonyu.iterator(_this.neighbors,1);
            case 7:
              if (!(_it_388.next())) { __pc=8     ; break; }
              _this.neighbor=_it_388[0];
              
              _this.s = new Tonyu.classes.user.Searcher({from: _this.neighbor,to: _this.to,path: _this.path.clone()});
              
              _this.allPaths = [];
              
              _this.s.on("result",(function anonymous_753(paths) {
                
                _this.allPaths=_this.allPaths.concat(paths);
                _this.count--;
                if (_this.count==0) {
                  _this.report(_this.allPaths);
                  
                }
              }));
              __pc=7;break;
            case 8     :
              
              _this.path.die();
              _this.alpha=128;
              __pc=12    ; break;
              
            case 9     :
              
            case 10    :
              
              _this.fiber$updateEx(_thread, 5);
              __pc=11;return;
            case 11:
              
              __pc=1;break;
            case 12    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      report :function _trc_Searcher_report(paths) {
        "use strict";
        var _this=this;
        
        _this.fireEvent("result",paths);
        _this.die();
      },
      fiber$report :function _trc_Searcher_f_report(_thread,paths) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.fireEvent("result",paths);
        _this.die();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"report":{"nowait":false}},"fields":{"path":{},"from":{},"to":{},"current":{},"neighbors":{},"neighbor":{},"count":{},"s":{},"allPaths":{}}}
});

//# sourceMappingURL=concat.js.map